---
title: RTCDTMFSender.toneBuffer
slug: Web/API/RTCDTMFSender/toneBuffer
tags:
  - Audio
  - DTMF
  - Media
  - Property
  - RTCDTMFSender
  - Reference
  - Telephony
  - Touch-tone
  - WebRTC
  - WebRTC API
  - toneBuffer
---
<div>{{APIRef("WebRTC")}}</div>

<p>The {{domxref("RTCDTMFSender")}} interface's toneBuffer property returns a string containing a list of the {{Glossary("DTMF")}} tones currently queued for sending to the remote peer over the {{domxref("RTCPeerConnection")}}. To place tones into the buffer, call {{domxref("RTCDTMFSender.insertDTMF", "insertDTMF()")}}.</p>

<p>Tones are removed from the string as they're played, so only upcoming tones are listed.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <code>toneBuffer</code> = <code>RTCDTMFSender</code>.toneBuffer;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} listing the tones to be played. If the string is empty, there are no tones pending.</p>

<h3 id="Tone_buffer_format">Tone buffer format</h3>

<p>The tone buffer is a string which can contain any combination of the characters that are permitted by the DTMF standard.</p>

<h4 id="DTMF_tone_characters">DTMF tone characters</h4>

<dl>
 <dt>The digits 0-9</dt>
 <dd>These characters represent the digit keys on a telephone keypad.</dd>
 <dt>The letters A-D</dt>
 <dd>These characters represent the "A" through "D" keys which are part of the DTMF standard but not included on most telephones. These are <em>not</em> interpreted as digits. Lower-case "a"-"d" automatically gets converted to upper-case.</dd>
 <dt>The pound/hash sign ("#") and the asterisk ("*")</dt>
 <dd>These correspond to the similarly-labeled keys which are typically on the bottom row of the telephone keypad.</dd>
 <dt>The comma (",")</dt>
 <dd>This character instructs the dialing process to pause for two seconds before sending the next character in the buffer.</dd>
</dl>

<div class="note">
<p>All other characters are unrecognized and will cause {{domxref("RTCDTMFSender.insertDTMF", "insertDTMF()")}} to throw an <code>InvalidCharacterError</code> exception.</p>
</div>

<h4 id="Using_tone_buffer_strings">Using tone buffer strings</h4>

<p>For example, if you're writing code to control a voicemail system by sending DTMF codes, you might use a string such as "*,1,5555". In this example, we would send "*" to request access to the VM system, then, after a pause, send a "1" to start playback of voicemail messages, then after a pause, dial "5555" as a PIN number to open the messages.</p>

<p>Settting the tone buffer to an empty string (<code>""</code>) cancels any pending DTMF codes.</p>

<h2 id="Example">Example</h2>

<p>tbd</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-RTCDTMFSender-tonebuffer', 'RTCDTMFSender.toneBuffer') }}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCDTMFSender.toneBuffer")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Using_DTMF">Using DTMF with WebRTC</a></li>
 <li>{{domxref("RTCDTMFSender.insertDTMF()")}}</li>
 <li>{{domxref("RTCPeerConnection")}}</li>
 <li>{{domxref("RTCDTMFSender")}}</li>
 <li>{{domxref("RTCRtpSender")}}</li>
</ul>
